// QLearning.cpp : Defines the entry point for the console application.

#include "stdafx.h"

#include <stdio.h>
#include <time.h>
#include <stdlib.h>
#include "windows.h"

float q_max(int s);
float** Q;

int main(int argc, char* argv[])
{
	srand((unsigned)time(NULL));//seed random generator

	int episodes	= 100;//how many rounds
	float alfa		= 0.3f;
	float gamma		= 0.8f;
	
	int R[10] = {-1,-1,-1,-1,-1,-1,-1,-1,-1,0};//Reward

	//randomly init the value-function values
	Q = new float*[10];
	for (int i=0;i<10;i++)
	{
		Q[i] = new float[2];
		
		int vorz = (rand()%2==0)?(-1):(1);
		Q[i][0] = vorz*1.0f/(float)rand();

		vorz = (rand()%2==0)?(-1):(1);
		Q[i][1] = vorz*1.0f/(float)rand();
	}

	for(i=0;i<episodes;i++)
	{
		int s=0;//first state

		//statistic vars
		int counter=0;
		int epsilon_taken=0;
		int left=0;
		int right=0;

		printf("Finding way...\n-----------------------------\n");
		while(s != 9)//not yet in endstate
		{
			int a;//action, 0 is left, 1 is right

			//choose action:
			if(s==0)a=1;//if in first state, just go right
			
			else if(rand() % (10+i) == 1)//at start: choose a random action every tenth time
			{							 //then decrease the probability in each run (explore less)
				a = rand() % 2;
				epsilon_taken++;//statistic
			}
			else// choose best action
			{
				if(q_max(s-1) > q_max(s+1))	a=0;
				else						a=1;
			}
			
			int s_new = (a == 0)?(s-1):(s+1);
			
			//the value-function: update the value of the action
			Q[s][a] = Q[s][a] + alfa*( R[s_new] + (gamma * q_max(s_new) - Q[s][a]) );			
			s = s_new;

			//visualisation
			if(a==0)printf("<");
			else printf(">");
			
			//statistic
			if(a==0)left++;else right++;
			counter++;
		}
		printf("\nstatistic:\n");
		printf("Nr: %d, steps: %d, random actions: %d, lefts: %d, rights: %d\n",i, counter, epsilon_taken, left, right);
		printf("\n\n");
		Sleep(4000);
	}
	printf("done");
	Sleep(5000);
	return 0;
}
float q_max(int s)
{
	if(s==0)return Q[s][1];//can't go left in state 0
	return ( Q[s][0] > Q[s][1] ) ? (Q[s][0]) : (Q[s][1]);
}